#include "stdafx.h"
#include "TreeOptionsCtrl.h"
#include "OpaqueShoe.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(COpaqueShoeButton, CTreeOptionsBrowseButton)

BEGIN_MESSAGE_MAP(COpaqueShoeButton, CTreeOptionsBrowseButton)
END_MESSAGE_MAP()

void COpaqueShoeButton::BrowseForOpaque()
{
  //Validate our parameters
  AFXASSUME(m_pTreeCtrl);

  //Bring up a our custom opaque editor dialog
  DWORD_PTR dwItem = m_pTreeCtrl->GetOpaque(m_hTreeCtrlItem);
  CShoeDialog dialog;
  dialog.SetShoeSize(static_cast<int>(dwItem));
  if (dialog.DoModal() == IDOK)
  {
    dwItem = dialog.GetShoeSize();
    m_pTreeCtrl->SetOpaque(m_hTreeCtrlItem, dwItem);
    switch (dwItem)
    {
      case 0:
      {
        m_pTreeCtrl->SetEditText(m_hTreeCtrlItem, _T("Small"));
        break;
      }
      case 1:
      {
        m_pTreeCtrl->SetEditText(m_hTreeCtrlItem, _T("Medium"));
        break;
      }
      case 2:
      {
        m_pTreeCtrl->SetEditText(m_hTreeCtrlItem, _T("Large"));
        break;
      }
      case 3:
      {
        m_pTreeCtrl->SetEditText(m_hTreeCtrlItem, _T("Extra Large"));
        break;
      }
      default:
      {
        ASSERT(FALSE);
        break;
      }
    }
  }
}


CShoeDialog::CShoeDialog(CWnd* pParent)	: CDialog(CShoeDialog::IDD, pParent),
                                          m_nShoeSize(-1)
{
}

void CShoeDialog::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CDialog::DoDataExchange(pDX);
  
  DDX_Radio(pDX, IDC_SMALL, m_nShoeSize);
}

BEGIN_MESSAGE_MAP(CShoeDialog, CDialog)
END_MESSAGE_MAP()

void CShoeDialog::SetShoeSize(int nItem)
{
  m_nShoeSize = nItem;
}

int CShoeDialog::GetShoeSize()
{
  return m_nShoeSize;
}


IMPLEMENT_DYNCREATE(CShoeComboBox, CTreeOptionsCombo)

BEGIN_MESSAGE_MAP(CShoeComboBox, CTreeOptionsCombo)
  ON_WM_CREATE()
END_MESSAGE_MAP()

int CShoeComboBox::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  //Let the base class do its thing
  if (CTreeOptionsCombo::OnCreate(lpCreateStruct) == -1)
    return -1;
  
  //Add some strings to the combo
  AddString(_T("Small"));
  AddString(_T("Medium"));
  AddString(_T("Large"));
  AddString(_T("Extra Large"));
  
  return 0;
}


IMPLEMENT_DYNCREATE(COpaqueShoeButton2, COpaqueShoeButton)

BEGIN_MESSAGE_MAP(COpaqueShoeButton2, COpaqueShoeButton)
END_MESSAGE_MAP()

void COpaqueShoeButton2::BrowseForOpaque()
{
  //Validate our parameters
  AFXASSUME(m_pCombo);

  m_pCombo->m_bDoNotDestroyUponLoseFocus = TRUE;

  //Bring up a our custom opaque editor dialog
  DWORD dwItem = m_pCombo->GetCurSel();
  CShoeDialog dialog;
  dialog.SetShoeSize(dwItem);
  if (dialog.DoModal() == IDOK)
  {
    dwItem = dialog.GetShoeSize();
    m_pCombo->SetCurSel(dwItem);
  }
  
  m_pCombo->m_bDoNotDestroyUponLoseFocus = FALSE;
}
