#include "stdafx.h"
#include "resource.h"
#include "MyPropertyPage1.h"
#include "..\DemoEditBox.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CMyPropertyPage1, CPropertyPage)

CMyPropertyPage1::CMyPropertyPage1() : CPropertyPage(CMyPropertyPage1::IDD),
                                       m_bAlt1(TRUE),
                                       m_bAlt2(FALSE),
                                       m_nSearchIndex(0),
                                       m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME)),
                                       m_hAccessibility(NULL),
                                       m_hAlt1(NULL),
                                       m_hAlt2(NULL),
                                       m_hSearch(NULL),
                                       m_hRadio1(NULL),
                                       m_hRadio2(NULL),
                                       m_hRadio3(NULL),
                                       m_hRadio4(NULL),
                                       m_hEditItem(NULL)
{
  m_ilTree.Create(IDB_TREE_CTRL_OPTIONS, 16, 1, RGB(255, 0, 255));
}

void CMyPropertyPage1::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CPropertyPage::DoDataExchange(pDX);

  DDX_Control(pDX, IDC_TREE1, m_ctrlTreeOptions);

  //Ensure no child controls are active
  if (pDX->m_bSaveAndValidate)
    m_ctrlTreeOptions.HandleChildControlLosingFocus();

  DDX_TreeEdit(pDX, IDC_TREE1, m_hEditItem, m_sEditItem);
}

BEGIN_MESSAGE_MAP(CMyPropertyPage1, CPropertyPage)
END_MESSAGE_MAP()

BOOL CMyPropertyPage1::OnInitDialog() 
{
  //Let the base class do its thing
  CPropertyPage::OnInitDialog();
  
  //Hook Up the image list for the tree control
  m_ctrlTreeOptions.SetImageList(&m_ilTree, TVSIL_NORMAL);

  //Remove any items which may be in the control already
  m_ctrlTreeOptions.DeleteAllItems();

  //Add some combo items to the control
  m_hAccessibility = m_ctrlTreeOptions.InsertGroup(_T("Accessibility (Example of check options)"), 3);
  m_hAlt1 = m_ctrlTreeOptions.InsertCheckBox(_T("Always expand ALT text for images"), m_hAccessibility, m_bAlt1);
  m_hAlt2 = m_ctrlTreeOptions.InsertCheckBox(_T("Move system caret with focus/selection changes"), m_hAccessibility, m_bAlt2);

  //Add some radio items to the control
  m_hSearch = m_ctrlTreeOptions.InsertGroup(_T("When Searching (Example of radio options)"), 0);
  m_hRadio1 = m_ctrlTreeOptions.InsertRadioButton(_T("Display results, and go to the most likely site"), m_hSearch, m_nSearchIndex == 0);
  m_hRadio2 = m_ctrlTreeOptions.InsertRadioButton(_T("Do not search from the Address bar"), m_hSearch, m_nSearchIndex == 1);
  m_hRadio3 = m_ctrlTreeOptions.InsertRadioButton(_T("Just display the results in the main window"), m_hSearch, m_nSearchIndex == 2);
  m_hRadio4 = m_ctrlTreeOptions.InsertRadioButton(_T("Just go to the most likely site"), m_hSearch, m_nSearchIndex == 3);

  //Add an edit box
  m_hEditItem = m_ctrlTreeOptions.InsertItem(_T("Your First Name (Example of edit box)"), 1, 1);
  m_ctrlTreeOptions.AddEditBox(m_hEditItem, RUNTIME_CLASS(CDemoEdit));

  //Initially have all the items expanded
  m_ctrlTreeOptions.Expand(m_hAccessibility, TVE_EXPAND);
  m_ctrlTreeOptions.Expand(m_hSearch, TVE_EXPAND);
  
  return TRUE;  // return TRUE unless you set the focus to a control
                // EXCEPTION: OCX Property Pages should return FALSE
}


IMPLEMENT_DYNCREATE(CMyPropertyPage2, CPropertyPage)

CMyPropertyPage2::CMyPropertyPage2() : CPropertyPage(CMyPropertyPage2::IDD)
{
}

void CMyPropertyPage2::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMyPropertyPage2, CPropertyPage)
END_MESSAGE_MAP()
