#include "stdafx.h"
#include "app.h"
#include "appDlg.h"
#include "DowComboBox.h"
#include "DemoEditBox.h"
#include "DemoSpinCtrl.h"
#include "OpaqueShoe.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CAppDlg::CAppDlg(CWnd* pParent) : CDialog(CAppDlg::IDD, pParent),
                                  m_bAlt1(TRUE),
                                  m_bAlt2(FALSE),
                                  m_nSearchIndex(0),
                                  m_sCombo(_T("Monday")),
                                  m_sEdit(_T("Your Name")),
                                  m_sSpinEdit(_T("3")),
                                  m_bSecurity(FALSE),
                                  m_bSSL2(FALSE),
                                  m_bSSL3(FALSE),
                                  m_Color(RGB(0, 0, 0)),
                                  m_sFontNameFace(_T("Times New Roman")),
                                  m_bBooleanValue(TRUE),
                                  m_bCB2(TRUE),
                                  m_sShoeItem(_T("Small")),
                                  m_sShoeItem2(_T("Small")),
                                  m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME)),
                                  m_hAccessibility(NULL),
                                  m_hAlt1(NULL),
                                  m_hAlt2(NULL),
                                  m_hSearch(NULL),
                                  m_hRadio1(NULL),
                                  m_hRadio2(NULL),
                                  m_hRadio3(NULL),
                                  m_hRadio4(NULL),
                                  m_hComboItem(NULL),
                                  m_hEditItem(NULL),
                                  m_hSecurity(NULL),
                                  m_hSSL2(NULL),
                                  m_hSSL3(NULL),
                                  m_hSpinCtrlItem(NULL),
                                  m_hBrowseForFileItem(NULL),
                                  m_hBrowseForFolderItem(NULL),
                                  m_hBrowseForColorItem(NULL),
                                  m_hBrowseForFont(NULL),
                                  m_hMisc(NULL),
                                  m_hFontNameComboItem(NULL),
                                  m_hBooleanComboItem(NULL),
                                  m_hCB2(NULL),
                                  m_hDateItem(NULL),
                                  m_hTimeItem(NULL),
                                  m_hIPAddressItem(NULL),
                                  m_hShoeItem(NULL),
                                  m_hShoeItem2(NULL),
                                  m_hMultiLineEdit(NULL),
                                  m_dwIPAddress(0)
{
  memset(&m_Font, 0, sizeof(m_Font));
  m_Font.lfCharSet = ANSI_CHARSET;
  _tcscpy_s(m_Font.lfFaceName, sizeof(m_Font.lfFaceName)/sizeof(TCHAR), _T("Times New Roman"));
  GetLocalTime(&m_Date);
  GetLocalTime(&m_Time);

  m_ilTree.Create(IDB_TREE_CTRL_OPTIONS, 16, 1, RGB(255, 0, 255));
}

void CAppDlg::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CDialog::DoDataExchange(pDX);

  DDX_Control(pDX, IDC_TREE1, m_ctrlTreeOptions);

  if (!pDX->m_bSaveAndValidate)
  {
    //Remove any items which may be in the control already
    m_ctrlTreeOptions.DeleteAllItems();

    //Add some combo items to the control
    m_hAccessibility = m_ctrlTreeOptions.InsertGroup(_T("Accessibility (Example of check options)"), 3);
    m_hAlt1 = m_ctrlTreeOptions.InsertCheckBox(_T("Always expand ALT text for images"), m_hAccessibility, m_bAlt1);
    m_hAlt2 = m_ctrlTreeOptions.InsertCheckBox(_T("Move system caret with focus/selection changes"), m_hAccessibility, m_bAlt2);

    //Add some radio items to the control
    m_hSearch = m_ctrlTreeOptions.InsertGroup(_T("When Searching (Example of radio options)"), 0);
    m_hRadio1 = m_ctrlTreeOptions.InsertRadioButton(_T("Display results, and go to the most likely site"), m_hSearch, m_nSearchIndex == 0);
    m_hRadio2 = m_ctrlTreeOptions.InsertRadioButton(_T("Do not search from the Address bar"), m_hSearch, m_nSearchIndex == 1);
    m_hRadio3 = m_ctrlTreeOptions.InsertRadioButton(_T("Just display the results in the main window"), m_hSearch, m_nSearchIndex == 2);
    m_hRadio4 = m_ctrlTreeOptions.InsertRadioButton(_T("Just go to the most likely site"), m_hSearch, m_nSearchIndex == 3);

    m_hCB2 = m_ctrlTreeOptions.InsertCheckBox(_T("Check Box item in a radio group"), m_hSearch, m_bCB2);

    //Add an edit box to the control
    m_hEditItem = m_ctrlTreeOptions.InsertItem(_T("Your First Name (Example of edit box)"), 1, 1);
    m_ctrlTreeOptions.AddEditBox(m_hEditItem, RUNTIME_CLASS(CDemoEdit));

    //Add a combo box item to the control
    m_hComboItem = m_ctrlTreeOptions.InsertItem(_T("Day of the Week (Example of combo box)"), 2, 2);
    m_ctrlTreeOptions.AddComboBox(m_hComboItem, RUNTIME_CLASS(CDowComboBox));

    //Add a check box item which will be the parent of collection of check boxes
    m_hSecurity = m_ctrlTreeOptions.InsertCheckBox(_T("Security"), TVI_ROOT, m_bSecurity);
    m_hSSL2 = m_ctrlTreeOptions.InsertCheckBox(_T("Use SSL2"), m_hSecurity, m_bSSL2);
    m_hSSL3 = m_ctrlTreeOptions.InsertCheckBox(_T("Use SSL3"), m_hSecurity, m_bSSL3);

    //Add an edit box with a spin ctrl the control
    m_hSpinCtrlItem = m_ctrlTreeOptions.InsertItem(_T("Rating (Example of edit box + spin ctrl)"), 1, 1);
    m_ctrlTreeOptions.AddEditBox(m_hSpinCtrlItem, RUNTIME_CLASS(CDemoEdit), RUNTIME_CLASS(CDemoSpin));

    m_hMisc = m_ctrlTreeOptions.InsertGroup(_T("Misc"), 3);

    //Add a folder and file browser to the control
    m_hBrowseForFileItem = m_ctrlTreeOptions.InsertItem(_T("A File edit box"), 4, 4, m_hMisc);
    m_ctrlTreeOptions.AddFileEditBox(m_hBrowseForFileItem, RUNTIME_CLASS(CTreeOptionsEdit), RUNTIME_CLASS(CTreeOptionsBrowseButton));
    m_hBrowseForFolderItem = m_ctrlTreeOptions.InsertItem(_T("A Folder edit box"), 4, 4, m_hMisc);
    m_ctrlTreeOptions.AddFolderEditBox(m_hBrowseForFolderItem, RUNTIME_CLASS(CTreeOptionsEdit), RUNTIME_CLASS(CTreeOptionsBrowseButton));

    //Add a color browser to the control
    m_hBrowseForColorItem = m_ctrlTreeOptions.InsertItem(_T("A Color selector"), 0, 0, m_hMisc);
    m_ctrlTreeOptions.AddColorSelector(m_hBrowseForColorItem, RUNTIME_CLASS(CTreeOptionsBrowseButton));

    //Add a font browser to the control
    m_hBrowseForFont = m_ctrlTreeOptions.InsertItem(_T("A Font selector"), 5, 5, m_hMisc);
    m_ctrlTreeOptions.AddFontSelector(m_hBrowseForFont, RUNTIME_CLASS(CTreeOptionsBrowseButton));

    //Add a font name combo box to the control
    m_hFontNameComboItem = m_ctrlTreeOptions.InsertItem(_T("A Font Name combo"), 5, 5, m_hMisc);
    m_ctrlTreeOptions.AddComboBox(m_hFontNameComboItem, RUNTIME_CLASS(CTreeOptionsFontNameCombo));

    //Add a boolean combo box to the control
    m_hBooleanComboItem = m_ctrlTreeOptions.InsertItem(_T("A Boolean combo"), 6, 6, m_hMisc);
    m_ctrlTreeOptions.AddComboBox(m_hBooleanComboItem, RUNTIME_CLASS(CTreeOptionsBooleanCombo));

    //Add a Date item  to the control
    m_hDateItem = m_ctrlTreeOptions.InsertItem(_T("Date example "), 7, 7, m_hMisc);
    m_ctrlTreeOptions.AddDateTime(m_hDateItem, RUNTIME_CLASS(CTreeOptionsDateCtrl));

    //Add a Time item  to the control
    m_hTimeItem = m_ctrlTreeOptions.InsertItem(_T("Time example "), 7, 7, m_hMisc);
    m_ctrlTreeOptions.AddDateTime(m_hTimeItem, RUNTIME_CLASS(CTreeOptionsTimeCtrl));

    //Add a IP Address to the control
    m_hIPAddressItem = m_ctrlTreeOptions.InsertItem(_T("An IP Address selector"), 8, 8, m_hMisc);
    m_ctrlTreeOptions.AddIPAddress(m_hIPAddressItem, RUNTIME_CLASS(CTreeOptionsIPAddressCtrl));

    //Add a opaque browser item example to the control
    m_hShoeItem = m_ctrlTreeOptions.InsertItem(_T("Your Shoe Size !!"), 9, 9, m_hMisc);
    m_ctrlTreeOptions.AddOpaque(m_hShoeItem, RUNTIME_CLASS(COpaqueShoeButton), NULL, 0);

    //Add a second example of an opaque browser item example to the control
    m_hShoeItem2 = m_ctrlTreeOptions.InsertItem(_T("Your Shoe Size (Combo)!!"), 9, 9);
    m_ctrlTreeOptions.AddOpaque(m_hShoeItem2, RUNTIME_CLASS(CShoeComboBox), RUNTIME_CLASS(COpaqueShoeButton2), 0);

    //Add an example of a multi line edit control
    m_hMultiLineEdit = m_ctrlTreeOptions.InsertItem(_T("A Multi line edit control"), 9, 9);
    m_ctrlTreeOptions.AddEditBox(m_hMultiLineEdit, RUNTIME_CLASS(CDemoMultiLineEdit));
    m_ctrlTreeOptions.SetMultiLineEditText(m_hMultiLineEdit, _T("Line 1\r\nLine 2"));

    //Initially have all the items expanded
    m_ctrlTreeOptions.Expand(m_hAccessibility, TVE_EXPAND);
    m_ctrlTreeOptions.Expand(m_hSearch, TVE_EXPAND);
    m_ctrlTreeOptions.Expand(m_hSecurity, TVE_EXPAND);
    m_ctrlTreeOptions.Expand(m_hMisc, TVE_EXPAND);
  }

  //Try out the DDX functions
  DDX_TreeCheck(pDX, IDC_TREE1, m_hAlt1, m_bAlt1);
  DDX_TreeCheck(pDX, IDC_TREE1, m_hAlt2, m_bAlt2);
  DDX_TreeRadio(pDX, IDC_TREE1, m_hSearch, m_nSearchIndex);
  DDX_TreeEdit (pDX, IDC_TREE1, m_hEditItem, m_sEdit);
  DDX_TreeCombo(pDX, IDC_TREE1, m_hComboItem, m_sCombo);
  DDX_TreeCheck(pDX, IDC_TREE1, m_hSecurity, m_bSecurity);
  DDX_TreeCheck(pDX, IDC_TREE1, m_hSSL2, m_bSSL2);
  DDX_TreeCheck(pDX, IDC_TREE1, m_hSSL3, m_bSSL3);
  DDX_TreeEdit (pDX, IDC_TREE1, m_hSpinCtrlItem, m_sSpinEdit);
  DDX_TreeColor(pDX, IDC_TREE1, m_hBrowseForColorItem, m_Color);
  DDX_TreeFont (pDX, IDC_TREE1, m_hBrowseForFont, &m_Font);
  DDX_TreeCombo(pDX, IDC_TREE1, m_hFontNameComboItem, m_sFontNameFace);
  DDX_TreeBoolean(pDX, IDC_TREE1, m_hBooleanComboItem, m_bBooleanValue);
  DDX_TreeCheck(pDX, IDC_TREE1, m_hCB2, m_bCB2);
  DDX_TreeDateTime(pDX, IDC_TREE1, m_hDateItem, m_Date);
  DDX_TreeDateTime(pDX, IDC_TREE1, m_hTimeItem, m_Time);
  DDX_TreeIPAddress(pDX, IDC_TREE1, m_hIPAddressItem, m_dwIPAddress);
  DDX_TreeEdit(pDX, IDC_TREE1, m_hShoeItem, m_sShoeItem);
  DDX_TreeCombo(pDX, IDC_TREE1, m_hShoeItem2, m_sShoeItem2);
}

BEGIN_MESSAGE_MAP(CAppDlg, CDialog)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_DISABLE_CHECK, CAppDlg::OnDisableCheck)
  ON_BN_CLICKED(IDC_DISABLE_GROUP, CAppDlg::OnDisableGroup)
  ON_BN_CLICKED(IDC_DISABLE_RADIO, CAppDlg::OnDisableRadio)
  ON_BN_CLICKED(IDC_ENABLE_CHECK, CAppDlg::OnEnableCheck)
  ON_BN_CLICKED(IDC_ENABLE_GROUP, CAppDlg::OnEnableGroup)
  ON_BN_CLICKED(IDC_ENABLE_RADIO, CAppDlg::OnEnableRadio)
  ON_BN_CLICKED(IDC_DISABLE_GROUP2, CAppDlg::OnDisableGroup2)
  ON_BN_CLICKED(IDC_ENABLE_GROUP2, CAppDlg::OnEnableGroup2)
  ON_BN_CLICKED(IDC_DISABLE_SECURITY, CAppDlg::OnDisableSecurity)
  ON_BN_CLICKED(IDC_ENABLE_SECURITY, CAppDlg::OnEnableSecurity)
  ON_BN_CLICKED(IDC_DISABLE_THEMES, CAppDlg::OnDisableThemes)
  ON_BN_CLICKED(IDC_ENABLE_THEMES, CAppDlg::OnEnableThemes)
  ON_BN_CLICKED(IDC_TOGGLE_CHILD_CHECKBOX, CAppDlg::ToggleChildCheckBox)
END_MESSAGE_MAP()

BOOL CAppDlg::OnInitDialog()
{
  //Let the base class do its thing
  CDialog::OnInitDialog();

  //Setup the dialog icons
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //Hook Up the image list for the tree control
  m_ctrlTreeOptions.SetImageList(&m_ilTree, TVSIL_NORMAL);

  return TRUE;
}

void CAppDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); //device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    //Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    CDialog::OnPaint();
}

HCURSOR CAppDlg::OnQueryDragIcon()
{
  return static_cast<HCURSOR>(m_hIcon);
}

void CAppDlg::OnEnableGroup() 
{
  m_ctrlTreeOptions.SetGroupEnable(m_hSearch, TRUE);
}

void CAppDlg::OnDisableGroup() 
{
  m_ctrlTreeOptions.SetGroupEnable(m_hSearch, FALSE);
}

void CAppDlg::OnEnableGroup2() 
{
  m_ctrlTreeOptions.SetGroupEnable(m_hAccessibility, TRUE);  
}

void CAppDlg::OnDisableGroup2() 
{
  m_ctrlTreeOptions.SetGroupEnable(m_hAccessibility, FALSE);
}

void CAppDlg::OnEnableCheck() 
{
  m_ctrlTreeOptions.SetCheckBoxEnable(m_hAlt1, TRUE);	
}

void CAppDlg::OnDisableCheck() 
{
  m_ctrlTreeOptions.SetCheckBoxEnable(m_hAlt1, FALSE);
}

void CAppDlg::OnEnableRadio() 
{
  m_ctrlTreeOptions.SetRadioButtonEnable(m_hRadio1, TRUE);
}

void CAppDlg::OnDisableRadio() 
{
  m_ctrlTreeOptions.SetRadioButtonEnable(m_hRadio1, FALSE);
}

void CAppDlg::OnDisableSecurity() 
{
  m_ctrlTreeOptions.SetCheckBoxEnable(m_hSecurity, FALSE);
}

void CAppDlg::OnEnableSecurity() 
{
  m_ctrlTreeOptions.SetCheckBoxEnable(m_hSecurity, TRUE);
}

void CAppDlg::OnDisableThemes() 
{
  m_ctrlTreeOptions.SetUseThemes(FALSE);
}

void CAppDlg::OnEnableThemes() 
{
  m_ctrlTreeOptions.SetUseThemes(TRUE);
}

void CAppDlg::ToggleChildCheckBox()
{
  BOOL bCheck = FALSE;
  m_ctrlTreeOptions.GetCheckBox(m_hSSL2, bCheck);
  m_ctrlTreeOptions.SetCheckBox(m_hSSL2, !bCheck);
}